Bullet Collision Detection & Physics Library: btContactConstraint Class Reference

Bullet Collision Detection & Physics Library

Public Member Functions | Protected Attributes | List of all members
btContactConstraint Class Reference

btContactConstraint can be automatically created to solve contact constraints using the unified btTypedConstraint interface More...

`#include <btContactConstraint.h>`

Inheritance diagram for btContactConstraint:
[legend]
Collaboration diagram for btContactConstraint:
[legend]

## Public Member Functions
| btContactConstraint (btPersistentManifold *contactManifold, btRigidBody &rbA, btRigidBody &rbB)
void | setContactManifold (btPersistentManifold *contactManifold)
btPersistentManifold * | getContactManifold ()
const btPersistentManifold * | getContactManifold () const
virtual | ~btContactConstraint ()
virtual void | getInfo1 (btConstraintInfo1 *info)
| internal method used by the constraint solver, don't use them directly More...
virtual void | getInfo2 (btConstraintInfo2 *info)
| internal method used by the constraint solver, don't use them directly More...
virtual void | buildJacobian ()
| obsolete methods More...
Public Member Functions inherited from btTypedConstraint
| BT_DECLARE_ALIGNED_ALLOCATOR ()
virtual | ~btTypedConstraint ()
| btTypedConstraint (btTypedConstraintType type, btRigidBody &rbA)
| btTypedConstraint (btTypedConstraintType type, btRigidBody &rbA, btRigidBody &rbB)
int | getOverrideNumSolverIterations () const
void | setOverrideNumSolverIterations (int overideNumIterations)
| override the number of constraint solver iterations used to solve this constraint -1 will use the default number of iterations, as specified in SolverInfo.m_numIterations More...
virtual void | setupSolverConstraint (btConstraintArray &ca, int solverBodyA, int solverBodyB, btScalar timeStep)
| internal method used by the constraint solver, don't use them directly More...
void | internalSetAppliedImpulse (btScalar appliedImpulse)
| internal method used by the constraint solver, don't use them directly More...
btScalar | internalGetAppliedImpulse ()
| internal method used by the constraint solver, don't use them directly More...
btScalar | getBreakingImpulseThreshold () const
void | setBreakingImpulseThreshold (btScalar threshold)
bool | isEnabled () const
void | setEnabled (bool enabled)
virtual void | solveConstraintObsolete (btSolverBody &, btSolverBody &, btScalar)
| internal method used by the constraint solver, don't use them directly More...
const btRigidBody & | getRigidBodyA () const
const btRigidBody & | getRigidBodyB () const
btRigidBody & | getRigidBodyA ()
btRigidBody & | getRigidBodyB ()
int | getUserConstraintType () const
void | setUserConstraintType (int userConstraintType)
void | setUserConstraintId (int uid)
int | getUserConstraintId () const
void | setUserConstraintPtr (void *ptr)
void * | getUserConstraintPtr ()
void | setJointFeedback (btJointFeedback *jointFeedback)
const btJointFeedback * | getJointFeedback () const
btJointFeedback * | getJointFeedback ()
int | getUid () const
bool | needsFeedback () const
void | enableFeedback (bool needsFeedback)
| enableFeedback will allow to read the applied linear and angular impulse use getAppliedImpulse, getAppliedLinearImpulse and getAppliedAngularImpulse to read feedback information More...
btScalar | getAppliedImpulse () const
| getAppliedImpulse is an estimated total applied impulse. More...
btTypedConstraintType | getConstraintType () const
void | setDbgDrawSize (btScalar dbgDrawSize)
btScalar | getDbgDrawSize ()
virtual void | setParam (int num, btScalar value, int axis=-1)=0
| override the default global value of a parameter (such as ERP or CFM), optionally provide the axis (0..5). More...
virtual btScalar | getParam (int num, int axis=-1) const =0
| return the local value of parameter More...
virtual int | calculateSerializeBufferSize () const
virtual const char * | serialize (void *dataBuffer, btSerializer *serializer) const
| fills the dataBuffer and returns the struct name (and 0 on failure) More...
Public Member Functions inherited from btTypedObject
| btTypedObject (int objectType)
int | getObjectType () const

## Protected Attributes
btPersistentManifold | m_contactManifold
Protected Attributes inherited from btTypedConstraint
btRigidBody & | m_rbA
btRigidBody & | m_rbB
btScalar | m_appliedImpulse
btScalar | m_dbgDrawSize
btJointFeedback * | m_jointFeedback

## Additional Inherited Members
Static Public Member Functions inherited from btTypedConstraint
static btRigidBody & | getFixedBody ()
Public Attributes inherited from btTypedObject
int | m_objectType
Protected Member Functions inherited from btTypedConstraint
btScalar | getMotorFactor (btScalar pos, btScalar lowLim, btScalar uppLim, btScalar vel, btScalar timeFact)
| internal method used by the constraint solver, don't use them directly More...

## Detailed Description

btContactConstraint can be automatically created to solve contact constraints using the unified btTypedConstraint interface

Definition at line 25 of file btContactConstraint.h.

## Constructor & Destructor Documentation

## § btContactConstraint()

btContactConstraint::btContactConstraint | ( | btPersistentManifold * | contactManifold,
|  | btRigidBody & | rbA,
|  | btRigidBody & | rbB
| ) |  |

Definition at line 27 of file btContactConstraint.cpp.

## § ~btContactConstraint()

btContactConstraint::~btContactConstraint | ( |  | ) |
| virtual

Definition at line 34 of file btContactConstraint.cpp.

## Member Function Documentation

## § buildJacobian()

void btContactConstraint::buildJacobian | ( |  | ) |
| virtual

obsolete methods

Reimplemented from btTypedConstraint.

Definition at line 54 of file btContactConstraint.cpp.

## § getContactManifold() [1/2]

btPersistentManifold* btContactConstraint::getContactManifold | ( |  | ) |
| inline

Definition at line 38 of file btContactConstraint.h.

## § getContactManifold() [2/2]

const btPersistentManifold* btContactConstraint::getContactManifold | ( |  | ) | const
| inline

Definition at line 43 of file btContactConstraint.h.

## § getInfo1()

void btContactConstraint::getInfo1 | ( | btConstraintInfo1 * | info | ) |
| virtual

internal method used by the constraint solver, don't use them directly

Implements btTypedConstraint.

Definition at line 44 of file btContactConstraint.cpp.

## § getInfo2()

void btContactConstraint::getInfo2 | ( | btConstraintInfo2 * | info | ) |
| virtual

internal method used by the constraint solver, don't use them directly

Implements btTypedConstraint.

Definition at line 49 of file btContactConstraint.cpp.

## § setContactManifold()

void btContactConstraint::setContactManifold | ( | btPersistentManifold * | contactManifold | ) |

Definition at line 39 of file btContactConstraint.cpp.

## Member Data Documentation

## § m_contactManifold

btPersistentManifold btContactConstraint::m_contactManifold
| protected

Definition at line 29 of file btContactConstraint.h.

The documentation for this class was generated from the following files:

- btContactConstraint.h
- btContactConstraint.cpp